# History of News/Releases

Project **started on August 4th, 2008**. The reason was that we were not satisfied with JaMON in terms of simplicity
and monitor structure and so we created our own sort-of clone with some enhancements (nanoseconds,
monitors in tree structure). Our **first release** was finished on **December 15th, 2008** and Java Simon contained
first version of the core and **JDBC Proxy driver** at that time.

**Second version** was released on **June 19th, 2009** and brought **JMX support, Spring AOP integration** and also a little
overhaul of the core API based on the feedback generated by the first version. Little additions and fixes followed
during the subsequent 2.x releases with active periods alternating with some slower ones. Besides constant
bug-fixing (thanks to our users) we added **Maven support** and basic **Java EE support** (Servlet filter, EJB interceptor).

**Third version** dropped JDK 5 dependency (and JDBC3 proxy driver in favour of JDBC4 version) and came out on
**October 11th, 2011**. We moved to **Maven Central** (group-id org.javasimon) and further improved Java EE support.
Embeddable web-console was added in version 3.2.

## 4.1.1 - 2015-10-11

* Fixed [Spring StopWatch show wrong classname.methodname in case of class hierarchy](https://github.com/virgo47/javasimon/issues/14)
* Fixed [EnabledManager.getOrCreateSimon() is synchronized](https://github.com/virgo47/javasimon/issues/13)

## 4.1.0 - 2015-06-03

* [Deadlock problem when using Split.stop(String) with more than one subSimon name and SimonManager.clear()](https://github.com/virgo47/javasimon/issues/11)
* [Add support for sampleIncrementNoReset](https://github.com/virgo47/javasimon/issues/12)
* pushing `StopwatchInfo` to upper level under name `ReporterStopwatchInfo`, it didn't make sense to have it as inner class of `DefaultRequestReporter` (probably historical reason)
* JDBC fixes: fixed driver class name (accident) and NPE if `driver.properties` are not found
* `Callback.Event` codes are internally lowercased before used as a key or when returning event by the code (fixes matching)

## 4.0.1 - 2014-12-17

Console bugfixes:

* https://github.com/virgo47/javasimon/issues/5
* https://github.com/virgo47/javasimon/pull/4

## 4.0.0 - 2014-10-28

* Version 4 requires Java 7 or higher
* Fix https://github.com/virgo47/javasimon/issues/1

## 3.5.2 - 2014-10-13

* Fix: https://code.google.com/p/javasimon/issues/detail?id=129

## 3.5.1 released (2014-05-31)

Version 3.5.1 fixes NPE in `SimonServletFilter` when init-param `stopwatch-source-props` is not present
(empty value would be probably workaround). If you are using servlet filter to measure your requests,
this fix is definitely for you.

## 3.5.0 released (2014-05-08)

Java Simon presents the last 3.x version (sans patches if necessary) - 3.5.0! It brings some nice features as a promise
to future 4.0 and also **it is the last version supporting Java SE 6** (again, some patches may come later).

* We added `Clock` abstraction that allows you to feed Simons with nano/millis values. This allows you to shift
timestamps in time (if needed), test it better, or even switch it to CPU user-time counter for instance.
* Utility methods for aggregation over a subtree were added, allowing you to sum up all Stopwatches or Counters,
or only the ones matching `SimonFilter`. Check `SimonUtils.calculate*Aggregate` methods.
* Major addition is "incremental sampling". You can now sample incremental change since the last sample -
and do it for multiple clients or periods on the same Simon. Check `Simon.sampleIncrement(key)`. **This
effectively deprecates `sampleAndReset` and `reset` as well.** Both will be removed in 4.0.
* And some bugfixes - check the whole [ release notes here](https://code.google.com/p/javasimon/issues/list?can=1&q=Milestone%3D3.5).

Check the Maven OSS repository (see MavenSupport page) and
[Javadocs](http://javasimon.googlecode.com/git-history/with-javadoc/api-3.5/index.html). In overall we are very
positive about this version, especially because of the incremental sampling, which is definitely the right way
to go if we want to offer any cluster/aggregation support in the future. Other than that it's your
good old Simon as you know it. :-) Enjoy

## 3.4.0 released (2013-08-22)

Slowly, but surely and proudly we are marching on - with another fixes + little features release.
Release notes are [here](http://code.google.com/p/javasimon/issues/list?can=1&q=Milestone%3D3.4), with these highlights:

* [ Splits can now use attributes too](http://code.google.com/p/javasimon/issues/detail?id=100) - no out of box support yet, but you can for instance store actual parameters of the method call in them for your own Callbacks.
* Some JDBC enhancements/fixes like [this](http://code.google.com/p/javasimon/issues/detail?id=102),
[this](http://code.google.com/p/javasimon/issues/detail?id=103) and [this](http://code.google.com/p/javasimon/issues/detail?id=104).
* [Console shows active field for Stopwatches too](http://code.google.com/p/javasimon/issues/detail?id=101).
* You can [sample multiple Simons with one JMX call](http://code.google.com/p/javasimon/issues/detail?id=109).
* There are also [better defaults for Simon Servlet Filter](http://code.google.com/p/javasimon/issues/detail?id=110).
* Anonymous split is [created with factory method](http://code.google.com/p/javasimon/issues/detail?id=105), not with constructor.

Check the Maven repository (see MavenSupport page) and [Javadocs](http://javasimon.googlecode.com/git-history/with-javadoc/api-3.4/index.html) too.
There are minor interface changes (anonymous Split - anyone? :-)), but upgrades should be generally smooth.
And there are bugfixes, so upgrades are recommended.

## 3.3.0 released - mostly (harmless) fixes (2012-10-12)

**From now on we are releasing under [New 3-clause BSD License](http://en.wikipedia.org/wiki/BSD_licenses) leaving
GPL behind.** This should be generally good news for our users.

This is sort of wrap-up release of all the changes that went first into 3.2.1 and more that followed + at least
one renaming (`SimonManagerMXBean`) justifies the minor version bump. Most fixes and enhancements went into Console
and monitoring web-filter, but there is more to it - check it in
[this list](http://code.google.com/p/javasimon/issues/list?can=1&q=label%3AMilestone-3.3%20status%3AFixed%2CWontFix%2CVerified)
(combined with 3.2.1 fixes too).

## 3.2.1 released - better console and performance (2012-05-11)

3.2.1 is more than just a few fixes:

* Web Console UI overhaul, looks better and acts better :-) and doesn't cache on IE anymore.
* A few performance fixes - especially disabled manager overhead is now 50% of the previous version (on get/start/stop scenario), also some synchronization was overhauled and get/start/stop with enabled Stopwatch got 5-25% better (depends on thread count, OS, CPU and planet positions of course).
* `RequestReporters` were separated to own package + a few more useful implementations were added.

In overall I'm very excited about this version and I recommend update from 3.2.0 - should be smooth
and fixes to Console are really nice! Javadoc was updated to the latest 3.2.1 - URL is
[still the same](http://javasimon.googlecode.com/svn/javadoc/api-3.2/index.html).

## Note

Dates may be off a few days, as they may point to the news release, not the actual Maven release.